# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/config/config.bt_defaults.ipynb.

# %% auto 0
__all__ = ['error_if_present', 'overwrite_field', 'mode_logger', 'default_data_converter', 'compare_kwargs',
           'error_if_kwargs_mismatch', 'group', 'build_partial', 'path_results', 'path_models', 'path_data', 'load',
           'save', 'load_result', 'save_result', 'load_model', 'save_model', 'file_format', 'split', 'use_split_folder',
           'models_folder', 'estimator_io', 'result_io', 'verbose', 'name_logger', 'always_two_logs', 'save_splits',
           'component_returns_nothing', 'separate_labels', 'warning_if_nick_name_exists', 'propagate',
           'path_session_folder', 'session_filename', 'track', 'path_logger_folder', 'logger_filename',
           'logger_null_filename', 'stdout_logger', 'null_name_logger']

# %% ../../nbs/config/config.bt_defaults.ipynb 3
import os
import json
from pathlib import Path

# %% ../../nbs/config/config.bt_defaults.ipynb 5
error_if_present = False
overwrite_field = False
mode_logger = 'a'

# %% ../../nbs/config/config.bt_defaults.ipynb 7
default_data_converter = 'GenericConverter'
compare_kwargs=False
error_if_kwargs_mismatch=False
group='group_0'
build_partial=True

# %% ../../nbs/config/config.bt_defaults.ipynb 9
path_results=None
path_models=None
path_data='data'
load=True
save=True
load_result=True
save_result=True
load_model=True
save_model=True
file_format='parquet'

split='whole'
use_split_folder=True
models_folder='models'

estimator_io='pickle'
result_io='pickle'

verbose=None
name_logger='dsblocks'
always_two_logs=True

save_splits = dict(training=True,
                  test=True,
                  validation=True,
                  whole=True)

# %% ../../nbs/config/config.bt_defaults.ipynb 11
component_returns_nothing=False

# %% ../../nbs/config/config.bt_defaults.ipynb 13
separate_labels=False
warning_if_nick_name_exists=False
propagate=False
path_session_folder='session'
session_filename='pipeline.pk'
track=False

# %% ../../nbs/config/config.bt_defaults.ipynb 15
path_logger_folder='log'
logger_filename=None
logger_null_filename='null.log'
mode_logger='w'
stdout_logger=True
null_name_logger='no_logging'

# %% ../../nbs/config/config.bt_defaults.ipynb 17
def _overrride_defaults (dflt_vars):
    from dsblocks.config.bt_defaults import __all__
    config = None
    for loc in './.dsblocks', os.path.expanduser('~'), '/etc/dsblocks', os.environ.get('DSBLOCKS_CONF'):
        if loc is not None:
            path = Path (loc) / 'dsblocks.json'
            if path.exists():
                with open (path, 'rt') as f: config = json.load (f)
                break
    if config is not None:
        new_vars = {k: config[k] for k in set(__all__).intersection(config)}
        for k in new_vars:
            dflt_vars[k]=config[k]

# %% ../../nbs/config/config.bt_defaults.ipynb 18
_overrride_defaults (locals())
