# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/datasets/datasets.ipynb.

# %% auto 0
__all__ = ['DataSet']

# %% ../../nbs/datasets/datasets.ipynb 3
from pathlib import Path
import abc
import pandas as pd
import numpy as np
import logging

# dsblocks API
from ..config import bt_defaults as dflt
from ..utils.utils import set_logger

# %% ../../nbs/datasets/datasets.ipynb 6
class DataSet (metaclass=abc.ABCMeta):
    """Abstract DataSet class."""
    def __init__ (self, logger = None, verbose=dflt.verbose, **kwargs):
        """
        Initialize common attributes and fields, in particular the logger.

        Parameters
        ----------
        logger : logging.Logger or None, optional
            Logger used to write messages
        verbose : int, optional
            Verbosity, 0: warning or critical, 1: info, 2: debug.
        """
        if logger is None:
            self.logger = set_logger ('dsblocks', verbose=verbose)
        else:
            self.logger = logger
    @abc.abstractmethod
    def load (self):
        pass
