# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/utils/cli.ipynb.

# %% auto 0
__all__ = ['dsblocks_install_git_hooks', 'main_dsblocks_install_git_hooks']

# %% ../../nbs/utils/cli.ipynb 3
from nbdev.imports import *
from fastcore.script import *
from nbdev.export import *
from nbdev.merge import *
from nbdev.test import *
import os, sys, stat

# %% ../../nbs/utils/cli.ipynb 6
def dsblocks_install_git_hooks():
    "Install git hooks to clean/trust notebooks automatically"
    try: path = get_config().config_file.parent
    except: path = Path.cwd()
    hook_path = path/'.git'/'hooks'
    fn = hook_path/'pre-commit'
    hook_path.mkdir(parents=True, exist_ok=True)
    fn.write_text("""#!/bin/sh

echo "\n==================== pre-commit hook ===================="
# Export conda environment to yaml file
conda env export > envs/$CONDA_DEFAULT_ENV.yml
git add envs/$CONDA_DEFAULT_ENV.yml
""")

    os.chmod (fn, stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR | stat.S_IRGRP | stat.S_IWGRP | stat.S_IXGRP | stat.S_IROTH |  stat.S_IXOTH)

    os.makedirs ('envs', exist_ok=True)

@call_parse
def main_dsblocks_install_git_hooks():
    dsblocks_install_git_hooks ()
